<?php
/**
 * 保存菜单数据
 * @author 绛木子 <master@lixianhua.com>
 */
class TeMenu_Action extends Typecho_Widget implements Widget_Interface_Do{
	private $navigation;
	private $locations;

	public function execute(){
		$this->navigation = TeMenu_Plugin::getNavigation();
		if(!$this->navigation){
			$this->navigation = array();
		}
		$this->locations = TeMenu_Plugin::getLocations();
		if(!$this->locations){
			$this->locations = array();
		}
	}
	private function saveMenu(){
		$slug = $this->request->get('slug');
		$title = $this->request->get('title',$slug);
		if(empty($slug)){
			$this->response->throwJson(array('msg'=>'菜单标识不能为空'));
		}
		$data = array(
			'menu' => $this->request->getArray('menu'),
			'title' => $title
		);
		$rs = array();
		if(!isset($this->navigation[$slug]) || (isset($this->navigation[$slug]) && $this->navigation[$slug]['title'] != $title)){
			$rs['url'] = Helper::url('TeMenu/panel.php&slug='.$slug);
		}
		$this->navigation[$slug] = $data;
		$this->savePluginSettings();
		$this->response->throwJson($rs);
	}

	private function delMenu(){
		$slug = $this->request->get('slug');
		$title = $this->request->get('title',$slug);
		if(empty($slug)){
			$this->response->throwJson(array('msg'=>'菜单标识不能为空'));
		}
		if(isset($this->navigation[$slug])){
			unset($this->navigation[$slug]);
		}
		$this->savePluginSettings();
		$this->response->throwJson(array(
			'msg' => _t('菜单 %s 已删除',$title),
			'url' => Helper::url('TeMenu/panel.php')
		));
	}

	private function setLocations(){
		$locations = $this->request->getArray('locations');
		foreach($locations as $location=>$nav){
			if(isset($this->locations[$location]) && !empty($nav) && isset($this->navigation[$nav]) && $nav != $this->locations[$location]['navigation']){
				$this->locations[$location]['navigation'] = $nav;
			}
		}
		$this->savePluginSettings();
		$this->response->throwJson(array('msg'=>'已设置菜单位置'));
	}

	private function savePluginSettings(){
		$setting = array(
			'navigation' => json_encode($this->navigation),
			'locations' => json_encode(array(Helper::options()->theme => $this->locations))
		);
		Helper::configPlugin('TeMenu', $setting);
	}

    public function action(){
		$this->widget('Widget_User')->pass('administrator');

		$this->on($this->request->is('op=save'))->saveMenu();
		$this->on($this->request->is('op=del'))->delMenu();
		$this->on($this->request->is('op=locations'))->setLocations();

		$this->response->throwJson(array('msg'=>_t('未知操作')));
    }
}